
;Scripts para JAWS  y E-Diccionarios Espasa versin 2.0 
;Copyright (C) 2004, ONCE CIDAT.
;Script tradotti e adattati per l'italiano dal CISAD in Marzo 2007


include "hjGlobal.jsh"
include "hjconst.jsh"
include "common.jsm"
include "bself.jsh"
include "bself.jsm"

;variables globales
globals

;handle de la ventana principal de la aplicacin
   handle principal,
;handle de la ventana del rbol de categoras
   handle ArbolCategorias,
;handle de la ventana con la lista de palabras del diccionario
   handle ListaPalabras,
;Ventana que contiene la definicin de la palabra
   handle DefinicionPalabra,
; handle del cuadro de edicin de bsqueda de palabras
   handle buscar, 
;Handle de la ventana buscar en el contenido
   handle buscarContenido,
;variable para controlar el orden de tabulacin
int estoyEnBusqueda,
   int PrimeraVez,
int jawsVersion,
int leerAuto,
string lingua;

;Funcin que se ejecuta cuando iniciamos la aplicacin por primera vez
;Inicializa los valores de las ventanas si es la primera vez que ejecutamos el script 
function AutoStartEvent ()
						let lingua="Italian"
                  let leerAuto = 0
                  sayMessage(OT_APP_START,MsgInicial)
                  let PrimeraVez = 1
                  let estoyEnBusqueda = 1
                  InicializarHandleVentanas ()
endFunction


;Funcin ejecutada al cerrar la aplicacin o cuando sta pierde el foco.
function autoFinishEvent ()
    if isJawsCursor() then
     pcCursor()
  endIf
endFunction



;Funcin que inicializa todos los handles de las ventanas del diccionario
;Navega por la aplicacin y asigna valores a las distintas variables handle
 Void Function InicializarHandleVentanas ()
  var
     int contador;
let estoyEnBusqueda=1
      let contador=1

;se obtiene el handle de la ventana principal
      let principal=GetTopLevelWindow(GetCurrentWindow());

      let ListaPalabras=GetFirstChild(principal)

  while (contador <= 4)
       let ListaPalabras=GetNextWindow(ListaPalabras)
       let contador = contador+1
  endWhile
  let contador=1
  while (contador <= 3)
       let ListaPalabras = getFirstChild(ListaPalabras)
       let contador=contador+1
  endWhile

  let DefinicionPalabra=getFirstChild(principal)
  let DefinicionPalabra=GetNextWindow(getFirstChild(definicionPalabra))

  let contador=1
  let ArbolCategorias=getFirstChild(principal)
  while contador <= 2
       let ArbolCategorias=getNextWindow(ArbolCategorias)
       let contador=contador+1
  endWhile

  let contador=1
  while contador <= 3
       let ArbolCategorias=getFirstChild(ArbolCategorias)
       let contador=contador+1
  endWhile
  let contador=1
  while contador <= 5
       let ArbolCategorias = getNextWindow(ArbolCategorias)     
       let contador=contador+1
  endWhile
  
  let contador=1
  let buscar=getFirstChild(principal)
  while contador <= 4
        let buscar=getNextWindow(buscar)
        let contador = contador+1
  endWhile
  let contador=1
  while contador <= 3
        let buscar=getFirstChild(buscar)
        let contador = contador+1
  endWhile
  let buscar=getNextWindow(buscar)

let contador = 1
let buscarContenido = getFirstChild(principal)
while contador <= 2
let buscarContenido=getNextWindow(buscarContenido)
let contador = contador+1
endWhile
let contador=1
while contador <= 3
let BuscarContenido=getFirstChild(buscarContenido)
let contador = contador+1
endWhile

EndFunction


;Funcin que se procesa cada vez que pulsamos una tecla.
;Se utiliza para leer los resultados en el cuadro de edicin bsqueda
;Y para ir a la definicin cuando pulsamos intro en el cuadro de edicin de bsqueda o en la lista de palabras.
;procesa la tecla tabulacin, para establecer un orden de tabulacin entre las distintas ventanas del diccionario
void function keyPressedEvent (int tecla)
var
  string palabra;
  if getWindowClass(getCurrentWindow())== "Edit" && tecla<=LETRAS then
        speechoff()
        routeJawsToPc()
        delay(3)
     	SetRestriction (RestrictWindow)
        speechon()
        sayLine()
        pcCursor()
        if (tecla == INTRO) then
                 delay(1)
                 performScript IrAVentanaDefinicion()
        endIf
 endIf
        if (tecla==INTRO && getWindowClass(GetCurrentWindow())=="SysListView32") then
                 delay(1)
                 performScript IrAVentanaDefinicion()
        endIf

  if tecla == TABULADOR then
;Comprueba si el handle de las ventanas ha cambiado, si cambia  actualiza los nuevos valores
  if GetTopLevelWindow(GetCurrentWindow())!=principal then
                 InicializarHandleVentanas()
  endIf
  if estoyEnBusqueda == 1 then
            let EstoyEnBusqueda = 0
sayMessage(OT_MESSAGE,"Lista delle parole")
            buscarPosicionPalabra()
            LeftMouseButton ()
            PcCursor()
else
               if GetCurrentWindow() == definicionPalabra then
                     pcCursor()
sayMessage(OT_MESSAGE,"Albero del dizionario")
                     moveToWindow(arbolCategorias)
                     leftMouseButton()
                     pcCursor()
 else
                    if getCurrentWindow() == listaPalabras && estoyEnBusqueda == 0 then
  moveToWindow(DefinicionPalabra)
  SetRestriction (RestrictWindow)
jawsPageUp()
jawsHome()
let palabra=getLine()
sayMessage(OT_MESSAGE,"Definizione")
sayMessage(OT_MESSAGE,palabra)
                          moveToWindow(DefinicionPalabra)
                          SetRestriction (RestrictWindow)
                          RouteBrailleToJAWS ()
                          setBrailleRestriction(RestrictWindow)
                          leftMouseButton()
  else
                                         if getCurrentWindow() == arbolCategorias then
let estoyEnBusqueda = 1
moveToWindow(buscar)
leftMouseButton()
pcCursor()
sayMessage(OT_MESSAGE,"Cerca: ")
endIf

                    endIf
              endIf
  endIf

  endIf

  if tecla == MAYUSCULATABULADORD || tecla == MAYUSCULATABULADORI then
;Comprueba si el handle de las ventanas ha cambiado, si cambia  actualiza los nuevos valores
  if GetTopLevelWindow(GetCurrentWindow())!=principal then
                 InicializarHandleVentanas()
  endIf
  if estoyEnBusqueda == 1 then
            let EstoyEnBusqueda = 0
            moveToWindow(arbolCategorias)
            LeftMouseButton ()
            PcCursor()
SayMessage(OT_MESSAGE,"albero del dizionario")
else
               if GetCurrentWindow() == definicionPalabra then
                     pcCursor()
buscarPosicionPalabra()
                     leftMouseButton()
                     pcCursor()
                     sayMessage(OT_MESSAGE,"Lista delle parole")
 else
                    if getCurrentWindow() == listaPalabras && estoyEnBusqueda == 0 then
let estoyEnBusqueda = 1
                          moveToWindow(Buscar)
leftMouseButton()
pcCursor()
sayMessage(OT_MESSAGE,"cerca: ")
else
                                         if getCurrentWindow() == arbolCategorias then
  moveToWindow(DefinicionPalabra)
  SetRestriction (RestrictWindow)
jawsPageUp()
jawsHome()
let palabra=getLine()
sayMessage(OT_MESSAGE,"Definizione")
sayMessage(OT_MESSAGE,palabra)
moveToWindow(DefinicionPalabra)
                          SetRestriction (RestrictWindow)
                          RouteBrailleToJAWS ()
                          setBrailleRestriction(RestrictWindow)
endIf

                    endIf
              endIf
  endIf

  endIf

  if (tecla == AVANCEPAGINA || tecla == RETROCESOPAGINA) && getCurrentWindow() == definicionPalabra then
      pcCursor()
      if tecla == AVANCEPAGINA then
                   {pageDown}
else 
         {PageUp}
endIf
jawsCursor()
endIf

  if getCurrentWindow()==definicionPalabra && !isJawsCursor() && tecla <= 80 && tecla != tabulador && !UserBufferIsActive() then
PerformScript irAVentanaDefinicion()
  endIf

  
endFunction	


; Script asignado a las flechas de cursor arriba y abajo, se mueve por el rbol de categoras y anuncia el estado de la categora (seleecionado / no seleccionado)
Script navegararbolmateriasabajo ()
  if (GetWindowClass(GetCurrentWindow()) == "SysTreeView32" && isPcCursor()) then
              SpeechOff()
              NextLine()
              SpeechOn()
              RouteJAWSToPc ()
              JawsCursor()
              PriorWord ()
              SayCharacter()
              NextWord()
              sayWord()
              pcCursor()
  else
              SayNextLine()
  EndIf
EndScript


;script asignado a las flechas de cursor arriba y abajo, se mueve por el rbol de materias y anuncia el estado de la materia (seleecionado / no seleccionado)
Script navegararbolmateriasarriba ()

  if (GetWindowClass(GetCurrentWindow())=="SysTreeView32" && isPcCursor()) then
             PriorLine()
             RouteJAWSToPc ()
             JawsCursor()
             PriorWord ()
             SayCharacter()
             NextWord()
             SayWord()
             PcCursor()
  else
             SayPriorLine()
  EndIf

EndScript




;Sita el foco en el rbol de materias.
Script iraarbolmaterias ()


;Comprueba si el handle de las ventanas ha cambiado, si cambia  actualiza los nuevos valores
  if GetTopLevelWindow(GetCurrentWindow())!=principal then
             InicializarHandleVentanas()
  endIf
  moveToWindow(ArbolCategorias)
  leftMouseButton()
  pcCursor()
sayMessage(OT_MESSAGE,"albero del dizionario.")
   
EndScript


;Se asigna a la barra espaciadora, en el rbol de materia selecciona o deselecciona un elemento y anuncia el estado
Script activardesactivarmateria ()

  if (GetWindowClass(GetCurrentWindow())=="SysTreeView32" && isPcCursor()) then
            speechOff ()
            {space}
            Delay (1)
            speechOn ()
            RouteJAWSToPc ()
            JawsCursor()
            PriorWord ()
            SayCharacter ()
            NextWord()
            SayWord()
            PcCursor()
  else
           {space}
  EndIf

EndScript

;script para ir a la ventana de definicin de la palabra seleccionada, restringe el cursor de jaws a dicha ventana 
Script iraventanadefinicion ()
var
  string palabra;

;Comprueba si el handle de las ventanas ha cambiado, si cambia  actualiza los nuevos valores
  if GetTopLevelWindow(GetCurrentWindow())!=principal then
             InicializarHandleVentanas()
  endIf
  moveToWindow(DefinicionPalabra)
  SetRestriction (RestrictWindow)
jawsPageUp()
jawsHome()
let palabra=getLine()
sayMessage(OT_MESSAGE,"Definizione")
sayMessage(OT_MESSAGE,palabra)


  moveToWindow(DefinicionPalabra)
  SetRestriction (RestrictWindow)
  
  RouteBrailleToJAWS ()
  setBrailleRestriction(RestrictWindow)
leftMouseButton()

EndScript


Script iralistadeterminos ()

  pcCursor()

;Comprueba si el handle de las ventanas ha cambiado, si cambia  actualiza los nuevos valores
  if GetTopLevelWindow(GetCurrentWindow())!=principal then
                 InicializarHandleVentanas()
  endIf
buscarPosicionPalabra()
  LeftMouseButton ()
  PcCursor()
  SayMessage(OT_MESSAGE,"Lista delle parole")

EndScript



;funcin de default.jss, lee el contenido de la lnea anterior
Function SayPriorLine()
var
	int TheTypeCode
PriorLine()
if leerAuto == 1 && getCurrentWindow() == listaPalabras then 
performScript decirDefinicionPalabra()
endIf
if (IsLeftButtonDown ()) then
	SelectingText(TRUE)
	pause ()
	SelectingText(false)
	return
endIf
if not IsPCCursor () then
	SayLine()
	return
endIf
let TheTypeCode = GetWindowSubTypeCode (GetCurrentWindow ())
If ! TheTypeCode then
	Let TheTypeCode = GetObjectSubTypeCode ()
EndIf
If (TheTypeCode == WT_TASKBAR) then
	SayWord ()
	Return
endIf
if (TheTypeCode == WT_UPDOWNSLIDER) || (TheTypeCode == WT_LEFTRIGHTSLIDER) then
	SayWord ()
	return
endIf
if (TheTypeCode == WT_TABCONTROL) then
	SayWord()
	return
endIf
if theTypeCode==wt_edit_spinbox then
	Say(GetLine(),OT_LINE)
	return
endIf
if theTypeCode==wt_editCombo then
	;sayWindow(globalFocusWindow,read_everything)
	return
endIf
if CaretVisible() then
	SayLine()
	return
endIf
If ((TheTypeCode == WT_MULTISELECT_LISTBOX) || (TheTypeCode == WT_EXTENDEDSELECT_LISTBOX)) then
	SayLine()
endIf
If TheTypeCode==WT_TreeView Then
	SayTreeViewLevel()
endIf

EndFunction


;Funcin de default.jss, lee el contenido de la lnea siguiente.
function SayNextLine()
var
	int TheTypeCode
NextLine()
;Si el modo lectura est activado, y estamos en la ventana de listaPalabras, leer la ventana definicin.
if leerAuto == 1 && getCurrentWindow() == listaPalabras then
performScript decirDefinicionPalabra()
endIf

if (IsLeftButtonDown ()) then
	SelectingText(TRUE)
	pause ()
	SelectingText(false)
	return
endIf
if  not IsPCCursor () then
	SayLine ()
	return
endIf
let TheTypeCode = GetWindowSubTypeCode (GetCurrentWindow ())
If ! TheTypeCode then
	Let TheTypeCode = GetObjectSubTypeCode ()
EndIf
If (TheTypeCode == WT_TASKBAR) then
	SayWord ()
	Return
endIf
if (TheTypeCode == WT_UPDOWNSLIDER) || (TheTypeCode == WT_LEFTRIGHTSLIDER) then
	SayWord ()
	return
endIf
if (TheTypeCode == WT_TABCONTROL) then
	SayWord()
	return
endIf
if theTypeCode==wt_edit_spinbox then
	Say(GetLine(),OT_LINE)
	return
endIf
if theTypeCode==wt_editCombo then
	;sayWindow(globalFocusWindow,read_everything)
	return
endIf
if CaretVisible () then
	SayLine ()
	return
endIf
If ((TheTypeCode == WT_MULTISELECT_LISTBOX) || (TheTypeCode == WT_EXTENDEDSELECT_LISTBOX)) then
	SayLine()
endIf
If TheTypeCode==WT_TreeView Then
	SayTreeViewLevel()
endIf
EndFunction




;script que visualiza el contenido de la ventana de definicin de la palabra en el visualizador virtual.
Script visualizardefinicion ()

var
string definicion;

if (getWindowClass(getCurrentWindow()) == "AfxFrameOrView42s") then
PassKeyThrough ()
 {ctrl+c}
delay (1)
;let definicion =getClipboardText()
let definicion = getWindowText(definicionPalabra,false)
 
 userBufferActivate()
userBufferClear()
userBufferAddText(definicion,"Definizione")
endIf
EndScript

Script irabuscar ()
  let estoyEnBusqueda = 1
;comprueba si el handle de las ventanas a cambiado
  if GetTopLevelWindow(GetCurrentWindow())!=principal then
             InicializarHandleVentanas()
  endIf
  moveToWindow(buscar)
  leftMouseButton()
  pcCursor()
  sayMessage(OT_MESSAGE,"Cerca:")
  JawsEnd()

EndScript

Script irabuscarcontenido ()

;comprueba si el handle de las ventanas a cambiado
  if GetTopLevelWindow(GetCurrentWindow())!=principal then
             InicializarHandleVentanas()
  endIf
  moveToWindow(buscarContenido)
  leftMouseButton()
  pcCursor()

EndScript


Script leerestadocategoria ()
var
string categoria;

speechOff()
saveCursor()
jawsCursor()
setRestriction(RestrictAppWindow)
jawsPageDown()
jawsHome()

nextWord()
let categoria = GetToEndOfLine ()
restoreCursor()
speechOn()
sayMessage(OT_MESSAGE, categoria)

EndScript



Function buscarPosicionPalabra ()

var
string palabra,
int resultado,
int longitud;


  if GetTopLevelWindow(GetCurrentWindow())!=principal then
                 InicializarHandleVentanas()
  endIf
moveToWindow(definicionPalabra)
jawsPageUp()
let palabra = getLine()
let longitud = stringLength(palabra)
if longitud > 10 then
let palabra = StringLeft (palabra, longitud/2)
endIf

let resultado = FindString (listaPalabras, palabra, S_TOP, S_RESTRICTED)
if resultado == 1then
leftMouseButton()
pcCursor()
if jawsVersion > 600000 then
moveToWindow(listaPalabras)
endIf
else
moveToWindow(listaPalabras)
leftMouseButton()
pcCursor()
endIf

EndFunction



Script ayudaenlinea ()

moveToWindow(definicionPalabra)
leftMouseButton()
pcCursor()
delay(1)
 userBufferActivate()
userBufferClear()
userBufferAddText(AyudaCb1)
userBufferAddText(AyudaCmd1,"irArbolCategorias()",EAyudaCmd1)
userBufferAddText(AyudaCmd11,"lecturaAuto()",EAyudaCmd11)
userBufferAddText(AyudaCmd2,"irBuscar()",EAyudaCmd2)
userBufferAddText(AyudaCmd3,"irDefinicionPalabra()",EAyudaCmd3)
userBufferAddText(AyudaCmd10,"hablaDefinicionPalabra()",EAyudaCmd10)
userBufferAddText(AyudaCmd4,"irAListaTerminos()",EAyudaCmd4)
userBufferAddText(AyudaCmd5,"decirCategoria()",EAyudaCmd5)
userBufferAddText(AyudaCmd6,"irBuscarEnTexto()",EAyudaCmd6)
userBufferAddText(AyudaCmd7,"irVisualizarDefinicion()",EAyudaCmd7)
userBufferAddText(AyudaCmd8)
userBufferAddText(AyudaCmd9)
 

EndScript


String Function irAListaTerminos ()

  userBufferDeactivate()
  performScript irAlistaDeTerminos()

EndFunction


String Function irArbolCategorias ()

  userBufferDeactivate()
  delay(1)
  performScript IrAArbolMaterias()

EndFunction

String Function irDefinicionPalabra ()

  userBufferDeactivate()
  delay(1)
  performScript irAVentanaDefinicion()


EndFunction


string Function irBuscar ()

  userBufferDeactivate()
  performScript irABuscar()

EndFunction

String Function decirCategoria ()

  userBufferDeactivate()
  performScript leerEstadoCategoria ()

EndFunction


Function irVisualizarDefinicion ()

userBufferDeactivate()
performScript visualizarDefinicion()
 

EndFunction

Function irBuscarEnTexto ()

userBufferDeactivate()
performScript irAbuscarContenido()

EndFunction


Script ayudar ()

;Comprueba si el handle de las ventanas ha cambiado, si cambia  actualiza los nuevos valores
  if GetTopLevelWindow(GetCurrentWindow())!=principal then
                 InicializarHandleVentanas()
  endIf

if getCurrentWindow()==buscar then 
sayMessage(OT_HELP,ayudar1L,Ayudar1C)
elif getCurrentWindow()==listaPalabras then
sayMessage(OT_HELP,ayudar2L,Ayudar2C)
elif getCurrentWindow()==definicionPalabra then
sayMessage(OT_HELP,ayudar3L,Ayudar3C)
elif getCurrentWindow()==arbolCategorias then
sayMessage(OT_HELP,ayudar4L,Ayudar4C)
elif getCurrentWindow()==buscarContenido then
sayMessage(OT_HELP,ayudar5L,Ayudar5C)
else
sayMessage(OT_HELP,ayudar0L,Ayudar0C)
EndIf


EndScript




function hablaDefinicionPalabra()

;Comprueba si el handle de las ventanas ha cambiado, si cambia  actualiza los nuevos valores
  if GetTopLevelWindow(GetCurrentWindow())!=principal then
             InicializarHandleVentanas()
  endIf
sayWindow(DefinicionPalabra,READ_EVERYTHING)


EndFunction


Script decirdefinicionpalabra ()
hablaDefinicionPalabra()
EndScript


Void Function lecturaauto ()

if leerAuto == 0 then
let leerAuto = 1
sayMessage(OT_MESSAGE,"Lettura automatica attivata.")
else
let leerAuto = 0
sayMessage(OT_MESSAGE, "Lettura automatica disattivata.")
endIf

EndFunction

Script lecturaautomatica ()
lecturaAuto()
EndScript




Script cambialingua ()

if lingua=="Italian" then
let lingua="Castilian Spanish"
SetSynthLanguage ("Castilian Spanish")
say ("parla spagnolo",0)
else
let lingua="Italian"
SetSynthLanguage ("Italian")
say ("parla italiano",0)

endif

EndScript

